﻿using System;
using System.Collections.Generic;

namespace TestProject
{
    /// <summary>
    /// 프로그램
    /// </summary>
    class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        private static void Main()
        {
            List<TestMessage> sourceMessageList = new List<TestMessage>();

            sourceMessageList.Add(new TestMessage { Priority = 0, Key = "01" });
            sourceMessageList.Add(new TestMessage { Priority = 1, Key = "02" });
            sourceMessageList.Add(new TestMessage { Priority = 2, Key = "03" });
            sourceMessageList.Add(new TestMessage { Priority = 2, Key = "04" });
            sourceMessageList.Add(new TestMessage { Priority = 3, Key = "05" });
            sourceMessageList.Add(new TestMessage { Priority = 4, Key = "06" });
            sourceMessageList.Add(new TestMessage { Priority = 4, Key = "07" });

            ThreadSafePriorityQueue<string, TestMessage> messageQueue = new ThreadSafePriorityQueue<string, TestMessage>(5);

            foreach(TestMessage sourceMessage in sourceMessageList)
            {
                messageQueue.EnqueueItem(sourceMessage);

                Console.WriteLine("ENQUEUE ITEM : {0}, {1}", sourceMessage.Priority, sourceMessage.Key);
            }

            TestMessage message;

            do
            {
                message = messageQueue.DequeueItem();

                if(message == null)
                {
                    return;
                }

                Console.WriteLine("DEQUEUE ITEM : {0}, {1}", message.Priority, message.Key);
            }
            while(true);
        }

        #endregion
    }
}